

import socket
import binascii
import fcntl
import struct

def wake_on_lan(mac_address, broadcast_address):
    # 获取本地IP地址
    sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    sock.connect(("8.8.8.8", 80))
    local_ip = sock.getsockname()[0]
    sock.close()

    # 构造魔术包
    mac_address = mac_address.replace(':', '')
    magic_packet = b'\xFF' * 6 + binascii.unhexlify(mac_address) * 16

    # 创建UDP套接字
    sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    sock.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)

    # 绑定本地IP地址
    sock.bind((local_ip, 0))

    # 发送魔术包
    sock.sendto(magic_packet, (broadcast_address, 9))
    sock.close()

# 主机的MAC地址和广播地址 //请填写你的待唤醒主机的
mac_address = 'c8:7f:54:a1:19:41'
broadcast_address = '192.168.0.17'

# 调用唤醒函数
wake_on_lan(mac_address, broadcast_address)